/* SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause) */

/* THIS FILE IS AUTOGENERATED BY BPFTOOL! */
#ifndef __BPERF_LEADER_BPF_SKEL_H__
#define __BPERF_LEADER_BPF_SKEL_H__

#include <errno.h>
#include <stdlib.h>
#include <bpf/libbpf.h>

#define BPF_SKEL_SUPPORTS_MAP_AUTO_ATTACH 1

struct bperf_leader_bpf {
	struct bpf_object_skeleton *skeleton;
	struct bpf_object *obj;
	struct {
		struct bpf_map *events;
		struct bpf_map *prev_readings;
		struct bpf_map *diff_readings;
	} maps;
	struct {
		struct bpf_program *on_switch;
	} progs;
	struct {
		struct bpf_link *on_switch;
	} links;

#ifdef __cplusplus
	static inline struct bperf_leader_bpf *open(const struct bpf_object_open_opts *opts = nullptr);
	static inline struct bperf_leader_bpf *open_and_load();
	static inline int load(struct bperf_leader_bpf *skel);
	static inline int attach(struct bperf_leader_bpf *skel);
	static inline void detach(struct bperf_leader_bpf *skel);
	static inline void destroy(struct bperf_leader_bpf *skel);
	static inline const void *elf_bytes(size_t *sz);
#endif /* __cplusplus */
};

static void
bperf_leader_bpf__destroy(struct bperf_leader_bpf *obj)
{
	if (!obj)
		return;
	if (obj->skeleton)
		bpf_object__destroy_skeleton(obj->skeleton);
	free(obj);
}

static inline int
bperf_leader_bpf__create_skeleton(struct bperf_leader_bpf *obj);

static inline struct bperf_leader_bpf *
bperf_leader_bpf__open_opts(const struct bpf_object_open_opts *opts)
{
	struct bperf_leader_bpf *obj;
	int err;

	obj = (struct bperf_leader_bpf *)calloc(1, sizeof(*obj));
	if (!obj) {
		errno = ENOMEM;
		return NULL;
	}

	err = bperf_leader_bpf__create_skeleton(obj);
	if (err)
		goto err_out;

	err = bpf_object__open_skeleton(obj->skeleton, opts);
	if (err)
		goto err_out;

	return obj;
err_out:
	bperf_leader_bpf__destroy(obj);
	errno = -err;
	return NULL;
}

static inline struct bperf_leader_bpf *
bperf_leader_bpf__open(void)
{
	return bperf_leader_bpf__open_opts(NULL);
}

static inline int
bperf_leader_bpf__load(struct bperf_leader_bpf *obj)
{
	return bpf_object__load_skeleton(obj->skeleton);
}

static inline struct bperf_leader_bpf *
bperf_leader_bpf__open_and_load(void)
{
	struct bperf_leader_bpf *obj;
	int err;

	obj = bperf_leader_bpf__open();
	if (!obj)
		return NULL;
	err = bperf_leader_bpf__load(obj);
	if (err) {
		bperf_leader_bpf__destroy(obj);
		errno = -err;
		return NULL;
	}
	return obj;
}

static inline int
bperf_leader_bpf__attach(struct bperf_leader_bpf *obj)
{
	return bpf_object__attach_skeleton(obj->skeleton);
}

static inline void
bperf_leader_bpf__detach(struct bperf_leader_bpf *obj)
{
	bpf_object__detach_skeleton(obj->skeleton);
}

static inline const void *bperf_leader_bpf__elf_bytes(size_t *sz);

static inline int
bperf_leader_bpf__create_skeleton(struct bperf_leader_bpf *obj)
{
	struct bpf_object_skeleton *s;
	struct bpf_map_skeleton *map __attribute__((unused));
	int err;

	s = (struct bpf_object_skeleton *)calloc(1, sizeof(*s));
	if (!s)	{
		err = -ENOMEM;
		goto err;
	}

	s->sz = sizeof(*s);
	s->name = "bperf_leader_bpf";
	s->obj = &obj->obj;

	/* maps */
	s->map_cnt = 3;
	s->map_skel_sz = 24;
	s->maps = (struct bpf_map_skeleton *)calloc(s->map_cnt,
			sizeof(*s->maps) > 24 ? sizeof(*s->maps) : 24);
	if (!s->maps) {
		err = -ENOMEM;
		goto err;
	}

	map = (struct bpf_map_skeleton *)((char *)s->maps + 0 * s->map_skel_sz);
	map->name = "events";
	map->map = &obj->maps.events;

	map = (struct bpf_map_skeleton *)((char *)s->maps + 1 * s->map_skel_sz);
	map->name = "prev_readings";
	map->map = &obj->maps.prev_readings;

	map = (struct bpf_map_skeleton *)((char *)s->maps + 2 * s->map_skel_sz);
	map->name = "diff_readings";
	map->map = &obj->maps.diff_readings;

	/* programs */
	s->prog_cnt = 1;
	s->prog_skel_sz = sizeof(*s->progs);
	s->progs = (struct bpf_prog_skeleton *)calloc(s->prog_cnt, s->prog_skel_sz);
	if (!s->progs) {
		err = -ENOMEM;
		goto err;
	}

	s->progs[0].name = "on_switch";
	s->progs[0].prog = &obj->progs.on_switch;
	s->progs[0].link = &obj->links.on_switch;

	s->data = bperf_leader_bpf__elf_bytes(&s->data_sz);

	obj->skeleton = s;
	return 0;
err:
	bpf_object__destroy_skeleton(s);
	return err;
}

static inline const void *bperf_leader_bpf__elf_bytes(size_t *sz)
{
	static const char data[] __attribute__((__aligned__(8))) = "\
\x7f\x45\x4c\x46\x02\x01\x01\0\0\0\0\0\0\0\0\0\x01\0\xf7\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x20\x1a\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\x40\0\x16\0\
\x01\0\x85\0\0\0\x08\0\0\0\xbf\x08\0\0\0\0\0\0\xb7\x01\0\0\0\0\0\0\x63\x1a\xe4\
\xff\0\0\0\0\xbf\xa2\0\0\0\0\0\0\x07\x02\0\0\xe4\xff\xff\xff\x18\x01\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\x85\0\0\0\x01\0\0\0\xbf\x06\0\0\0\0\0\0\x15\x06\x23\0\0\0\0\
\0\xbf\xa2\0\0\0\0\0\0\x07\x02\0\0\xe4\xff\xff\xff\x18\x01\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\x85\0\0\0\x01\0\0\0\xbf\x07\0\0\0\0\0\0\x15\x07\x1c\0\0\0\0\0\x67\x08\
\0\0\x20\0\0\0\x77\x08\0\0\x20\0\0\0\xbf\xa3\0\0\0\0\0\0\x07\x03\0\0\xe8\xff\
\xff\xff\x18\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xbf\x82\0\0\0\0\0\0\xb7\x04\0\0\
\x18\0\0\0\x85\0\0\0\x37\0\0\0\x55\0\x12\0\0\0\0\0\x79\x61\0\0\0\0\0\0\x79\xa2\
\xe8\xff\0\0\0\0\x1f\x12\0\0\0\0\0\0\x7b\x27\0\0\0\0\0\0\x79\x61\x08\0\0\0\0\0\
\x79\xa2\xf0\xff\0\0\0\0\x1f\x12\0\0\0\0\0\0\x7b\x27\x08\0\0\0\0\0\x79\x61\x10\
\0\0\0\0\0\x79\xa2\xf8\xff\0\0\0\0\x1f\x12\0\0\0\0\0\0\x7b\x27\x10\0\0\0\0\0\
\x79\xa1\xf8\xff\0\0\0\0\x7b\x16\x10\0\0\0\0\0\x79\xa1\xf0\xff\0\0\0\0\x7b\x16\
\x08\0\0\0\0\0\x79\xa1\xe8\xff\0\0\0\0\x7b\x16\0\0\0\0\0\0\xb7\0\0\0\0\0\0\0\
\x95\0\0\0\0\0\0\0\x44\x75\x61\x6c\x20\x42\x53\x44\x2f\x47\x50\x4c\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x50\0\0\0\0\0\0\0\x70\x01\0\0\0\0\0\0\x01\0\
\x56\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x88\0\0\0\0\0\0\0\x70\x01\0\0\0\0\0\0\x01\
\0\x57\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xd8\0\0\0\0\0\0\0\x70\x01\0\0\0\0\0\0\
\x01\0\x50\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\x11\x01\x25\x0e\x13\x05\x03\x0e\
\x10\x17\x1b\x0e\x11\x01\x12\x06\0\0\x02\x34\0\x03\x0e\x49\x13\x3f\x19\x3a\x0b\
\x3b\x0b\x02\x18\0\0\x03\x01\x01\x49\x13\0\0\x04\x21\0\x49\x13\x37\x0b\0\0\x05\
\x24\0\x03\x0e\x3e\x0b\x0b\x0b\0\0\x06\x24\0\x03\x0e\x0b\x0b\x3e\x0b\0\0\x07\
\x13\x01\x0b\x0b\x3a\x0b\x3b\x0b\0\0\x08\x0d\0\x03\x0e\x49\x13\x3a\x0b\x3b\x0b\
\x38\x0b\0\0\x09\x0f\0\x49\x13\0\0\x0a\x21\0\x49\x13\x37\x05\0\0\x0b\x34\0\x03\
\x0e\x49\x13\x3a\x0b\x3b\x0b\0\0\x0c\x26\0\x49\x13\0\0\x0d\x15\0\x49\x13\x27\
\x19\0\0\x0e\x16\0\x49\x13\x03\x0e\x3a\x0b\x3b\x0b\0\0\x0f\x15\x01\x49\x13\x27\
\x19\0\0\x10\x05\0\x49\x13\0\0\x11\x0f\0\0\0\x12\x26\0\0\0\x13\x34\0\x03\x0e\
\x49\x13\x3a\x0b\x3b\x05\0\0\x14\x13\x01\x03\x0e\x0b\x0b\x3a\x0b\x3b\x05\0\0\
\x15\x0d\0\x03\x0e\x49\x13\x3a\x0b\x3b\x05\x38\x0b\0\0\x16\x2e\x01\x03\x0e\x3a\
\x0b\x3b\x0b\x27\x19\x49\x13\x20\x0b\0\0\x17\x05\0\x03\x0e\x3a\x0b\x3b\x0b\x49\
\x13\0\0\x18\x34\0\x03\x0e\x3a\x0b\x3b\x0b\x49\x13\0\0\x19\x2e\x01\x11\x01\x12\
\x06\x40\x18\x97\x42\x19\x03\x0e\x3a\x0b\x3b\x0b\x27\x19\x49\x13\x3f\x19\0\0\
\x1a\x1d\x01\x31\x13\x11\x01\x12\x06\x58\x0b\x59\x0b\x57\x0b\0\0\x1b\x34\0\x02\
\x18\x31\x13\0\0\x1c\x34\0\x02\x17\x31\x13\0\0\0\x2c\x03\0\0\x04\0\0\0\0\0\x08\
\x01\0\0\0\0\x1d\0\x2c\0\0\0\0\0\0\0\x4d\0\0\0\0\0\0\0\0\0\0\0\x80\x01\0\0\x02\
\xa2\0\0\0\x3f\0\0\0\x01\x37\x09\x03\0\0\0\0\0\0\0\0\x03\x4b\0\0\0\x04\x52\0\0\
\0\x0d\0\x05\xaa\0\0\0\x06\x01\x06\xaf\0\0\0\x08\x07\x02\xc3\0\0\0\x6e\0\0\0\
\x01\x0c\x09\x03\0\0\0\0\0\0\0\0\x07\x20\x01\x07\x08\xca\0\0\0\xa3\0\0\0\x01\
\x08\0\x08\xd3\0\0\0\xa3\0\0\0\x01\x09\x08\x08\xdc\0\0\0\xa3\0\0\0\x01\x0a\x10\
\x08\xe7\0\0\0\xbb\0\0\0\x01\x0b\x18\0\x09\xa8\0\0\0\x03\xb4\0\0\0\x04\x52\0\0\
\0\x04\0\x05\xcf\0\0\0\x05\x04\x09\xc0\0\0\0\x03\xb4\0\0\0\x0a\x52\0\0\0\0\x08\
\0\x02\xf1\0\0\0\xe2\0\0\0\x01\x13\x09\x03\0\0\0\0\0\0\0\0\x07\x20\x01\x0e\x08\
\xca\0\0\0\x17\x01\0\0\x01\x0f\0\x08\xd3\0\0\0\xa3\0\0\0\x01\x10\x08\x08\xdc\0\
\0\0\x28\x01\0\0\x01\x11\x10\x08\xff\0\0\0\x39\x01\0\0\x01\x12\x18\0\x09\x1c\
\x01\0\0\x03\xb4\0\0\0\x04\x52\0\0\0\x06\0\x09\x2d\x01\0\0\x03\xb4\0\0\0\x04\
\x52\0\0\0\x18\0\x09\x3e\x01\0\0\x03\xb4\0\0\0\x04\x52\0\0\0\x01\0\x02\x0b\x01\
\0\0\x5f\x01\0\0\x01\x1a\x09\x03\0\0\0\0\0\0\0\0\x07\x20\x01\x15\x08\xca\0\0\0\
\x17\x01\0\0\x01\x16\0\x08\xd3\0\0\0\xa3\0\0\0\x01\x17\x08\x08\xdc\0\0\0\x28\
\x01\0\0\x01\x18\x10\x08\xff\0\0\0\x39\x01\0\0\x01\x19\x18\0\x0b\x19\x01\0\0\
\x9f\x01\0\0\x03\xce\x0c\xa4\x01\0\0\x09\xa9\x01\0\0\x0d\xae\x01\0\0\x0e\xb9\
\x01\0\0\x3f\x01\0\0\x02\x1b\x05\x32\x01\0\0\x07\x04\x0b\x45\x01\0\0\xcb\x01\0\
\0\x03\x38\x0c\xd0\x01\0\0\x09\xd5\x01\0\0\x0f\xe5\x01\0\0\x10\xe5\x01\0\0\x10\
\xe6\x01\0\0\0\x11\x09\xeb\x01\0\0\x12\x13\x59\x01\0\0\xf8\x01\0\0\x03\xaa\x05\
\x0c\xfd\x01\0\0\x09\x02\x02\0\0\x0f\x1c\x02\0\0\x10\xe5\x01\0\0\x10\x23\x02\0\
\0\x10\x35\x02\0\0\x10\xae\x01\0\0\0\x05\x73\x01\0\0\x05\x08\x0e\x2e\x02\0\0\
\x8b\x01\0\0\x02\x1f\x05\x78\x01\0\0\x07\x08\x09\x3a\x02\0\0\x14\xa9\x01\0\0\
\x18\x04\xc4\x1b\x15\x91\x01\0\0\x23\x02\0\0\x04\xc5\x1b\0\x15\x99\x01\0\0\x23\
\x02\0\0\x04\xc6\x1b\x08\x15\xa1\x01\0\0\x23\x02\0\0\x04\xc7\x1b\x10\0\x16\xbe\
\x01\0\0\x01\x1d\xb4\0\0\0\x01\x17\xcc\x01\0\0\x01\x1d\xc5\x02\0\0\x18\xd0\x01\
\0\0\x01\x21\xae\x01\0\0\x18\xd5\x01\0\0\x01\x1f\x3a\x02\0\0\x18\xd9\x01\0\0\
\x01\x1f\x35\x02\0\0\x18\xe2\x01\0\0\x01\x1f\x35\x02\0\0\x18\xeb\x01\0\0\x01\
\x22\x1c\x02\0\0\x18\xef\x01\0\0\x01\x20\xae\x01\0\0\0\x09\x2e\x02\0\0\x19\0\0\
\0\0\0\0\0\0\x80\x01\0\0\x01\x5a\xf3\x01\0\0\x01\x1d\xb4\0\0\0\x17\xcc\x01\0\0\
\x01\x1d\xc5\x02\0\0\x1a\x6b\x02\0\0\0\0\0\0\0\0\0\0\x70\x01\0\0\x01\x1d\x05\
\x1b\x02\x91\x04\x82\x02\0\0\x1b\x02\x91\x08\x8d\x02\0\0\x1c\0\0\0\0\x98\x02\0\
\0\x1c\x23\0\0\0\xa3\x02\0\0\x1c\x46\0\0\0\xae\x02\0\0\0\0\0\x63\x6c\x61\x6e\
\x67\x20\x76\x65\x72\x73\x69\x6f\x6e\x20\x31\x37\x2e\x30\x2e\x36\x20\x28\x46\
\x65\x64\x6f\x72\x61\x20\x31\x37\x2e\x30\x2e\x36\x2d\x32\x2e\x66\x63\x33\x39\
\x29\0\x75\x74\x69\x6c\x2f\x62\x70\x66\x5f\x73\x6b\x65\x6c\x2f\x62\x70\x65\x72\
\x66\x5f\x6c\x65\x61\x64\x65\x72\x2e\x62\x70\x66\x2e\x63\0\x2f\x62\x75\x69\x6c\
\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\x64\x2f\x42\x55\x49\x4c\x44\x2f\x6b\x65\
\x72\x6e\x65\x6c\x2d\x36\x2e\x31\x31\x2e\x39\x2f\x6c\x69\x6e\x75\x78\x2d\x36\
\x2e\x31\x31\x2e\x39\x2d\x32\x30\x30\x2e\x76\x61\x6e\x69\x6c\x6c\x61\x2e\x66\
\x63\x33\x39\x2e\x70\x70\x63\x36\x34\x6c\x65\x2f\x74\x6f\x6f\x6c\x73\x2f\x70\
\x65\x72\x66\0\x4c\x49\x43\x45\x4e\x53\x45\0\x63\x68\x61\x72\0\x5f\x5f\x41\x52\
\x52\x41\x59\x5f\x53\x49\x5a\x45\x5f\x54\x59\x50\x45\x5f\x5f\0\x65\x76\x65\x6e\
\x74\x73\0\x74\x79\x70\x65\0\x69\x6e\x74\0\x6b\x65\x79\x5f\x73\x69\x7a\x65\0\
\x76\x61\x6c\x75\x65\x5f\x73\x69\x7a\x65\0\x6d\x61\x70\x5f\x66\x6c\x61\x67\x73\
\0\x70\x72\x65\x76\x5f\x72\x65\x61\x64\x69\x6e\x67\x73\0\x6d\x61\x78\x5f\x65\
\x6e\x74\x72\x69\x65\x73\0\x64\x69\x66\x66\x5f\x72\x65\x61\x64\x69\x6e\x67\x73\
\0\x62\x70\x66\x5f\x67\x65\x74\x5f\x73\x6d\x70\x5f\x70\x72\x6f\x63\x65\x73\x73\
\x6f\x72\x5f\x69\x64\0\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x69\x6e\x74\0\x5f\
\x5f\x75\x33\x32\0\x62\x70\x66\x5f\x6d\x61\x70\x5f\x6c\x6f\x6f\x6b\x75\x70\x5f\
\x65\x6c\x65\x6d\0\x62\x70\x66\x5f\x70\x65\x72\x66\x5f\x65\x76\x65\x6e\x74\x5f\
\x72\x65\x61\x64\x5f\x76\x61\x6c\x75\x65\0\x6c\x6f\x6e\x67\0\x75\x6e\x73\x69\
\x67\x6e\x65\x64\x20\x6c\x6f\x6e\x67\x20\x6c\x6f\x6e\x67\0\x5f\x5f\x75\x36\x34\
\0\x63\x6f\x75\x6e\x74\x65\x72\0\x65\x6e\x61\x62\x6c\x65\x64\0\x72\x75\x6e\x6e\
\x69\x6e\x67\0\x62\x70\x66\x5f\x70\x65\x72\x66\x5f\x65\x76\x65\x6e\x74\x5f\x76\
\x61\x6c\x75\x65\0\x5f\x5f\x5f\x5f\x6f\x6e\x5f\x73\x77\x69\x74\x63\x68\0\x63\
\x74\x78\0\x7a\x65\x72\x6f\0\x76\x61\x6c\0\x70\x72\x65\x76\x5f\x76\x61\x6c\0\
\x64\x69\x66\x66\x5f\x76\x61\x6c\0\x65\x72\x72\0\x6b\x65\x79\0\x6f\x6e\x5f\x73\
\x77\x69\x74\x63\x68\0\x9f\xeb\x01\0\x18\0\0\0\0\0\0\0\x74\x02\0\0\x74\x02\0\0\
\x14\x03\0\0\0\0\0\0\0\0\0\x02\x03\0\0\0\x01\0\0\0\0\0\0\x01\x04\0\0\0\x20\0\0\
\x01\0\0\0\0\0\0\0\x03\0\0\0\0\x02\0\0\0\x04\0\0\0\x04\0\0\0\x05\0\0\0\0\0\0\
\x01\x04\0\0\0\x20\0\0\0\0\0\0\0\0\0\0\x02\x06\0\0\0\0\0\0\0\0\0\0\x03\0\0\0\0\
\x02\0\0\0\x04\0\0\0\0\x08\0\0\0\0\0\0\x04\0\0\x04\x20\0\0\0\x19\0\0\0\x01\0\0\
\0\0\0\0\0\x1e\0\0\0\x01\0\0\0\x40\0\0\0\x27\0\0\0\x01\0\0\0\x80\0\0\0\x32\0\0\
\0\x05\0\0\0\xc0\0\0\0\x3c\0\0\0\0\0\0\x0e\x07\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\
\x02\x0a\0\0\0\0\0\0\0\0\0\0\x03\0\0\0\0\x02\0\0\0\x04\0\0\0\x06\0\0\0\0\0\0\0\
\0\0\0\x02\x0c\0\0\0\0\0\0\0\0\0\0\x03\0\0\0\0\x02\0\0\0\x04\0\0\0\x18\0\0\0\0\
\0\0\0\0\0\0\x02\x0e\0\0\0\0\0\0\0\0\0\0\x03\0\0\0\0\x02\0\0\0\x04\0\0\0\x01\0\
\0\0\0\0\0\0\x04\0\0\x04\x20\0\0\0\x19\0\0\0\x09\0\0\0\0\0\0\0\x1e\0\0\0\x01\0\
\0\0\x40\0\0\0\x27\0\0\0\x0b\0\0\0\x80\0\0\0\x43\0\0\0\x0d\0\0\0\xc0\0\0\0\x4f\
\0\0\0\0\0\0\x0e\x0f\0\0\0\x01\0\0\0\0\0\0\0\x04\0\0\x04\x20\0\0\0\x19\0\0\0\
\x09\0\0\0\0\0\0\0\x1e\0\0\0\x01\0\0\0\x40\0\0\0\x27\0\0\0\x0b\0\0\0\x80\0\0\0\
\x43\0\0\0\x0d\0\0\0\xc0\0\0\0\x5d\0\0\0\0\0\0\x0e\x11\0\0\0\x01\0\0\0\0\0\0\0\
\0\0\0\x02\x14\0\0\0\x6b\0\0\0\0\0\0\x01\x08\0\0\0\x40\0\0\0\0\0\0\0\x01\0\0\
\x0d\x02\0\0\0\x7e\0\0\0\x13\0\0\0\x82\0\0\0\x01\0\0\x0c\x15\0\0\0\xf9\x02\0\0\
\0\0\0\x01\x01\0\0\0\x08\0\0\x01\0\0\0\0\0\0\0\x03\0\0\0\0\x17\0\0\0\x04\0\0\0\
\x0d\0\0\0\xfe\x02\0\0\0\0\0\x0e\x18\0\0\0\x01\0\0\0\x06\x03\0\0\x03\0\0\x0f\0\
\0\0\0\x08\0\0\0\0\0\0\0\x20\0\0\0\x10\0\0\0\0\0\0\0\x20\0\0\0\x12\0\0\0\0\0\0\
\0\x20\0\0\0\x0c\x03\0\0\x01\0\0\x0f\0\0\0\0\x19\0\0\0\0\0\0\0\x0d\0\0\0\0\x69\
\x6e\x74\0\x5f\x5f\x41\x52\x52\x41\x59\x5f\x53\x49\x5a\x45\x5f\x54\x59\x50\x45\
\x5f\x5f\0\x74\x79\x70\x65\0\x6b\x65\x79\x5f\x73\x69\x7a\x65\0\x76\x61\x6c\x75\
\x65\x5f\x73\x69\x7a\x65\0\x6d\x61\x70\x5f\x66\x6c\x61\x67\x73\0\x65\x76\x65\
\x6e\x74\x73\0\x6d\x61\x78\x5f\x65\x6e\x74\x72\x69\x65\x73\0\x70\x72\x65\x76\
\x5f\x72\x65\x61\x64\x69\x6e\x67\x73\0\x64\x69\x66\x66\x5f\x72\x65\x61\x64\x69\
\x6e\x67\x73\0\x75\x6e\x73\x69\x67\x6e\x65\x64\x20\x6c\x6f\x6e\x67\x20\x6c\x6f\
\x6e\x67\0\x63\x74\x78\0\x6f\x6e\x5f\x73\x77\x69\x74\x63\x68\0\x72\x61\x77\x5f\
\x74\x70\x2f\x73\x63\x68\x65\x64\x5f\x73\x77\x69\x74\x63\x68\0\x2f\x62\x75\x69\
\x6c\x64\x64\x69\x72\x2f\x62\x75\x69\x6c\x64\x2f\x42\x55\x49\x4c\x44\x2f\x6b\
\x65\x72\x6e\x65\x6c\x2d\x36\x2e\x31\x31\x2e\x39\x2f\x6c\x69\x6e\x75\x78\x2d\
\x36\x2e\x31\x31\x2e\x39\x2d\x32\x30\x30\x2e\x76\x61\x6e\x69\x6c\x6c\x61\x2e\
\x66\x63\x33\x39\x2e\x70\x70\x63\x36\x34\x6c\x65\x2f\x74\x6f\x6f\x6c\x73\x2f\
\x70\x65\x72\x66\x2f\x75\x74\x69\x6c\x2f\x62\x70\x66\x5f\x73\x6b\x65\x6c\x2f\
\x62\x70\x65\x72\x66\x5f\x6c\x65\x61\x64\x65\x72\x2e\x62\x70\x66\x2e\x63\0\x09\
\x5f\x5f\x75\x33\x32\x20\x6b\x65\x79\x20\x3d\x20\x62\x70\x66\x5f\x67\x65\x74\
\x5f\x73\x6d\x70\x5f\x70\x72\x6f\x63\x65\x73\x73\x6f\x72\x5f\x69\x64\x28\x29\
\x3b\0\x09\x5f\x5f\x75\x33\x32\x20\x7a\x65\x72\x6f\x20\x3d\x20\x30\x3b\0\x09\
\x70\x72\x65\x76\x5f\x76\x61\x6c\x20\x3d\x20\x62\x70\x66\x5f\x6d\x61\x70\x5f\
\x6c\x6f\x6f\x6b\x75\x70\x5f\x65\x6c\x65\x6d\x28\x26\x70\x72\x65\x76\x5f\x72\
\x65\x61\x64\x69\x6e\x67\x73\x2c\x20\x26\x7a\x65\x72\x6f\x29\x3b\0\x09\x69\x66\
\x20\x28\x21\x70\x72\x65\x76\x5f\x76\x61\x6c\x29\0\x09\x64\x69\x66\x66\x5f\x76\
\x61\x6c\x20\x3d\x20\x62\x70\x66\x5f\x6d\x61\x70\x5f\x6c\x6f\x6f\x6b\x75\x70\
\x5f\x65\x6c\x65\x6d\x28\x26\x64\x69\x66\x66\x5f\x72\x65\x61\x64\x69\x6e\x67\
\x73\x2c\x20\x26\x7a\x65\x72\x6f\x29\x3b\0\x09\x69\x66\x20\x28\x21\x64\x69\x66\
\x66\x5f\x76\x61\x6c\x29\0\x09\x65\x72\x72\x20\x3d\x20\x62\x70\x66\x5f\x70\x65\
\x72\x66\x5f\x65\x76\x65\x6e\x74\x5f\x72\x65\x61\x64\x5f\x76\x61\x6c\x75\x65\
\x28\x26\x65\x76\x65\x6e\x74\x73\x2c\x20\x6b\x65\x79\x2c\x20\x26\x76\x61\x6c\
\x2c\x20\x73\x69\x7a\x65\x6f\x66\x28\x76\x61\x6c\x29\x29\x3b\0\x09\x69\x66\x20\
\x28\x65\x72\x72\x29\0\x09\x64\x69\x66\x66\x5f\x76\x61\x6c\x2d\x3e\x63\x6f\x75\
\x6e\x74\x65\x72\x20\x3d\x20\x76\x61\x6c\x2e\x63\x6f\x75\x6e\x74\x65\x72\x20\
\x2d\x20\x70\x72\x65\x76\x5f\x76\x61\x6c\x2d\x3e\x63\x6f\x75\x6e\x74\x65\x72\
\x3b\0\x09\x64\x69\x66\x66\x5f\x76\x61\x6c\x2d\x3e\x65\x6e\x61\x62\x6c\x65\x64\
\x20\x3d\x20\x76\x61\x6c\x2e\x65\x6e\x61\x62\x6c\x65\x64\x20\x2d\x20\x70\x72\
\x65\x76\x5f\x76\x61\x6c\x2d\x3e\x65\x6e\x61\x62\x6c\x65\x64\x3b\0\x09\x64\x69\
\x66\x66\x5f\x76\x61\x6c\x2d\x3e\x72\x75\x6e\x6e\x69\x6e\x67\x20\x3d\x20\x76\
\x61\x6c\x2e\x72\x75\x6e\x6e\x69\x6e\x67\x20\x2d\x20\x70\x72\x65\x76\x5f\x76\
\x61\x6c\x2d\x3e\x72\x75\x6e\x6e\x69\x6e\x67\x3b\0\x09\x2a\x70\x72\x65\x76\x5f\
\x76\x61\x6c\x20\x3d\x20\x76\x61\x6c\x3b\0\x69\x6e\x74\x20\x42\x50\x46\x5f\x50\
\x52\x4f\x47\x28\x6f\x6e\x5f\x73\x77\x69\x74\x63\x68\x29\0\x63\x68\x61\x72\0\
\x4c\x49\x43\x45\x4e\x53\x45\0\x2e\x6d\x61\x70\x73\0\x6c\x69\x63\x65\x6e\x73\
\x65\0\x9f\xeb\x01\0\x20\0\0\0\0\0\0\0\x14\0\0\0\x14\0\0\0\x8c\x01\0\0\xa0\x01\
\0\0\0\0\0\0\x08\0\0\0\x8c\0\0\0\x01\0\0\0\0\0\0\0\x16\0\0\0\x10\0\0\0\x8c\0\0\
\0\x18\0\0\0\0\0\0\0\xa0\0\0\0\x16\x01\0\0\x0e\x80\0\0\x18\0\0\0\xa0\0\0\0\x3f\
\x01\0\0\x08\x84\0\0\x28\0\0\0\xa0\0\0\0\0\0\0\0\0\0\0\0\x30\0\0\0\xa0\0\0\0\
\x50\x01\0\0\x0d\x90\0\0\x50\0\0\0\xa0\0\0\0\x88\x01\0\0\x06\x94\0\0\x60\0\0\0\
\xa0\0\0\0\x98\x01\0\0\x0d\xa0\0\0\x88\0\0\0\xa0\0\0\0\xd0\x01\0\0\x06\xa4\0\0\
\x90\0\0\0\xa0\0\0\0\xe0\x01\0\0\x2b\xb0\0\0\xb0\0\0\0\xa0\0\0\0\xe0\x01\0\0\
\x08\xb0\0\0\xd8\0\0\0\xa0\0\0\0\x23\x02\0\0\x06\xb4\0\0\xe0\0\0\0\xa0\0\0\0\
\x2d\x02\0\0\x2e\xc0\0\0\xe8\0\0\0\xa0\0\0\0\x2d\x02\0\0\x1a\xc0\0\0\xf0\0\0\0\
\xa0\0\0\0\x2d\x02\0\0\x22\xc0\0\0\xf8\0\0\0\xa0\0\0\0\x2d\x02\0\0\x14\xc0\0\0\
\0\x01\0\0\xa0\0\0\0\x63\x02\0\0\x2e\xc4\0\0\x08\x01\0\0\xa0\0\0\0\x63\x02\0\0\
\x1a\xc4\0\0\x10\x01\0\0\xa0\0\0\0\x63\x02\0\0\x22\xc4\0\0\x18\x01\0\0\xa0\0\0\
\0\x63\x02\0\0\x14\xc4\0\0\x20\x01\0\0\xa0\0\0\0\x99\x02\0\0\x2e\xc8\0\0\x28\
\x01\0\0\xa0\0\0\0\x99\x02\0\0\x1a\xc8\0\0\x30\x01\0\0\xa0\0\0\0\x99\x02\0\0\
\x22\xc8\0\0\x38\x01\0\0\xa0\0\0\0\x99\x02\0\0\x14\xc8\0\0\x40\x01\0\0\xa0\0\0\
\0\xcf\x02\0\0\x0e\xcc\0\0\x70\x01\0\0\xa0\0\0\0\xe1\x02\0\0\x05\x74\0\0\x0c\0\
\0\0\xff\xff\xff\xff\x04\0\x08\0\x08\x7c\x0b\0\x14\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\x80\x01\0\0\0\0\0\0\x72\x01\0\0\x04\0\xf3\0\0\0\x08\x01\x01\xfb\x0e\x0d\0\
\x01\x01\x01\x01\0\0\0\x01\0\0\x01\x75\x74\x69\x6c\x2f\x62\x70\x66\x5f\x73\x6b\
\x65\x6c\0\x2f\x75\x73\x72\x2f\x69\x6e\x63\x6c\x75\x64\x65\x2f\x61\x73\x6d\x2d\
\x67\x65\x6e\x65\x72\x69\x63\0\x6c\x69\x62\x62\x70\x66\x2f\x69\x6e\x63\x6c\x75\
\x64\x65\x2f\x62\x70\x66\0\x2f\x62\x75\x69\x6c\x64\x64\x69\x72\x2f\x62\x75\x69\
\x6c\x64\x2f\x42\x55\x49\x4c\x44\x2f\x6b\x65\x72\x6e\x65\x6c\x2d\x36\x2e\x31\
\x31\x2e\x39\x2f\x6c\x69\x6e\x75\x78\x2d\x36\x2e\x31\x31\x2e\x39\x2d\x32\x30\
\x30\x2e\x76\x61\x6e\x69\x6c\x6c\x61\x2e\x66\x63\x33\x39\x2e\x70\x70\x63\x36\
\x34\x6c\x65\x2f\x74\x6f\x6f\x6c\x73\0\0\x62\x70\x65\x72\x66\x5f\x6c\x65\x61\
\x64\x65\x72\x2e\x62\x70\x66\x2e\x63\0\x01\0\0\x69\x6e\x74\x2d\x6c\x6c\x36\x34\
\x2e\x68\0\x02\0\0\x62\x70\x66\x5f\x68\x65\x6c\x70\x65\x72\x5f\x64\x65\x66\x73\
\x2e\x68\0\x03\0\0\x69\x6e\x63\x6c\x75\x64\x65\x2f\x75\x61\x70\x69\x2f\x6c\x69\
\x6e\x75\x78\x2f\x62\x70\x66\x2e\x68\0\x04\0\0\0\x05\x0e\x0a\0\x09\x02\0\0\0\0\
\0\0\0\0\x03\x1f\x01\x06\x03\x60\x2e\x05\x08\x06\x03\x21\x20\x05\0\x06\x03\x5f\
\x2e\x05\x0d\x06\x03\x24\x20\x05\x06\x4b\x06\x03\x5b\x20\x05\x0d\x06\x03\x28\
\x20\x05\x06\x59\x05\x2b\x23\x05\x08\x06\x4a\x05\x06\x06\x59\x05\x2e\x23\x05\
\x1a\x06\x20\x05\x22\x20\x05\x14\x20\x05\x2e\x06\x21\x05\x1a\x06\x20\x05\x22\
\x20\x05\x14\x20\x05\x2e\x06\x21\x05\x1a\x06\x20\x05\x22\x20\x05\x14\x20\x05\
\x0e\x06\x21\x05\x05\x03\x6a\x66\x02\x02\0\x01\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\xca\0\0\0\x04\0\xf1\xff\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\x03\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xfe\0\0\0\0\0\x03\0\x70\
\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x03\0\x07\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x03\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x03\0\x0b\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x03\0\x10\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x03\0\x12\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x66\0\0\0\x12\0\x03\
\0\0\0\0\0\0\0\0\0\x80\x01\0\0\0\0\0\0\x2f\0\0\0\x11\0\x06\0\x20\0\0\0\0\0\0\0\
\x20\0\0\0\0\0\0\0\x3d\0\0\0\x11\0\x06\0\x40\0\0\0\0\0\0\0\x20\0\0\0\0\0\0\0\
\x22\0\0\0\x11\0\x06\0\0\0\0\0\0\0\0\0\x20\0\0\0\0\0\0\0\xf6\0\0\0\x11\0\x05\0\
\0\0\0\0\0\0\0\0\x0d\0\0\0\0\0\0\0\x30\0\0\0\0\0\0\0\x01\0\0\0\x0a\0\0\0\x68\0\
\0\0\0\0\0\0\x01\0\0\0\x0b\0\0\0\xb0\0\0\0\0\0\0\0\x01\0\0\0\x0c\0\0\0\x06\0\0\
\0\0\0\0\0\x03\0\0\0\x05\0\0\0\x0c\0\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x12\0\0\0\
\0\0\0\0\x03\0\0\0\x06\0\0\0\x16\0\0\0\0\0\0\0\x03\0\0\0\x08\0\0\0\x1a\0\0\0\0\
\0\0\0\x03\0\0\0\x06\0\0\0\x1e\0\0\0\0\0\0\0\x02\0\0\0\x02\0\0\0\x2b\0\0\0\0\0\
\0\0\x03\0\0\0\x06\0\0\0\x37\0\0\0\0\0\0\0\x02\0\0\0\x0d\0\0\0\x4c\0\0\0\0\0\0\
\0\x03\0\0\0\x06\0\0\0\x53\0\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x5a\0\0\0\0\0\0\0\
\x03\0\0\0\x06\0\0\0\x66\0\0\0\0\0\0\0\x02\0\0\0\x0c\0\0\0\x73\0\0\0\0\0\0\0\
\x03\0\0\0\x06\0\0\0\x7f\0\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x8b\0\0\0\0\0\0\0\
\x03\0\0\0\x06\0\0\0\x97\0\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\xb5\0\0\0\0\0\0\0\
\x03\0\0\0\x06\0\0\0\xce\0\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\xda\0\0\0\0\0\0\0\
\x02\0\0\0\x0a\0\0\0\xe7\0\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\xf3\0\0\0\0\0\0\0\
\x03\0\0\0\x06\0\0\0\xff\0\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x0b\x01\0\0\0\0\0\0\
\x03\0\0\0\x06\0\0\0\x4b\x01\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x57\x01\0\0\0\0\0\
\0\x02\0\0\0\x0b\0\0\0\x64\x01\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x70\x01\0\0\0\0\
\0\0\x03\0\0\0\x06\0\0\0\x7c\x01\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x88\x01\0\0\0\
\0\0\0\x03\0\0\0\x06\0\0\0\x95\x01\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\xb3\x01\0\0\
\0\0\0\0\x03\0\0\0\x06\0\0\0\xba\x01\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\xc1\x01\0\
\0\0\0\0\0\x03\0\0\0\x06\0\0\0\xed\x01\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x1d\x02\
\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x28\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x2f\
\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x3b\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\
\x44\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x51\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\0\
\0\x5e\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x6c\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\
\0\0\x78\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x83\x02\0\0\0\0\0\0\x03\0\0\0\x06\
\0\0\0\x8e\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\x99\x02\0\0\0\0\0\0\x03\0\0\0\
\x06\0\0\0\xa4\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\xaf\x02\0\0\0\0\0\0\x03\0\0\
\0\x06\0\0\0\xba\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\xcb\x02\0\0\0\0\0\0\x02\0\
\0\0\x02\0\0\0\xd9\x02\0\0\0\0\0\0\x03\0\0\0\x06\0\0\0\xe4\x02\0\0\0\0\0\0\x03\
\0\0\0\x06\0\0\0\xf3\x02\0\0\0\0\0\0\x02\0\0\0\x02\0\0\0\x13\x03\0\0\0\0\0\0\
\x03\0\0\0\x04\0\0\0\x1c\x03\0\0\0\0\0\0\x03\0\0\0\x04\0\0\0\x25\x03\0\0\0\0\0\
\0\x03\0\0\0\x04\0\0\0\x54\x02\0\0\0\0\0\0\x04\0\0\0\x0c\0\0\0\x60\x02\0\0\0\0\
\0\0\x04\0\0\0\x0a\0\0\0\x6c\x02\0\0\0\0\0\0\x04\0\0\0\x0b\0\0\0\x84\x02\0\0\0\
\0\0\0\x04\0\0\0\x0d\0\0\0\x2c\0\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x40\0\0\0\0\0\
\0\0\x04\0\0\0\x02\0\0\0\x50\0\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x60\0\0\0\0\0\0\
\0\x04\0\0\0\x02\0\0\0\x70\0\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x80\0\0\0\0\0\0\0\
\x04\0\0\0\x02\0\0\0\x90\0\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\xa0\0\0\0\0\0\0\0\
\x04\0\0\0\x02\0\0\0\xb0\0\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\xc0\0\0\0\0\0\0\0\
\x04\0\0\0\x02\0\0\0\xd0\0\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\xe0\0\0\0\0\0\0\0\
\x04\0\0\0\x02\0\0\0\xf0\0\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\0\x01\0\0\0\0\0\0\
\x04\0\0\0\x02\0\0\0\x10\x01\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x20\x01\0\0\0\0\0\
\0\x04\0\0\0\x02\0\0\0\x30\x01\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x40\x01\0\0\0\0\
\0\0\x04\0\0\0\x02\0\0\0\x50\x01\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x60\x01\0\0\0\
\0\0\0\x04\0\0\0\x02\0\0\0\x70\x01\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x80\x01\0\0\
\0\0\0\0\x04\0\0\0\x02\0\0\0\x90\x01\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\xa0\x01\0\
\0\0\0\0\0\x04\0\0\0\x02\0\0\0\xb0\x01\0\0\0\0\0\0\x04\0\0\0\x02\0\0\0\x14\0\0\
\0\0\0\0\0\x03\0\0\0\x07\0\0\0\x18\0\0\0\0\0\0\0\x02\0\0\0\x02\0\0\0\x03\x01\0\
\0\0\0\0\0\x02\0\0\0\x02\0\0\0\x09\x0d\x0c\x0a\x0b\0\x2e\x64\x65\x62\x75\x67\
\x5f\x61\x62\x62\x72\x65\x76\0\x2e\x74\x65\x78\x74\0\x2e\x72\x65\x6c\x2e\x42\
\x54\x46\x2e\x65\x78\x74\0\x65\x76\x65\x6e\x74\x73\0\x2e\x6d\x61\x70\x73\0\x70\
\x72\x65\x76\x5f\x72\x65\x61\x64\x69\x6e\x67\x73\0\x64\x69\x66\x66\x5f\x72\x65\
\x61\x64\x69\x6e\x67\x73\0\x2e\x64\x65\x62\x75\x67\x5f\x73\x74\x72\0\x2e\x72\
\x65\x6c\x2e\x64\x65\x62\x75\x67\x5f\x69\x6e\x66\x6f\0\x6f\x6e\x5f\x73\x77\x69\
\x74\x63\x68\0\x2e\x72\x65\x6c\x72\x61\x77\x5f\x74\x70\x2f\x73\x63\x68\x65\x64\
\x5f\x73\x77\x69\x74\x63\x68\0\x2e\x6c\x6c\x76\x6d\x5f\x61\x64\x64\x72\x73\x69\
\x67\0\x6c\x69\x63\x65\x6e\x73\x65\0\x2e\x72\x65\x6c\x2e\x64\x65\x62\x75\x67\
\x5f\x6c\x69\x6e\x65\0\x2e\x72\x65\x6c\x2e\x64\x65\x62\x75\x67\x5f\x66\x72\x61\
\x6d\x65\0\x2e\x64\x65\x62\x75\x67\x5f\x6c\x6f\x63\0\x62\x70\x65\x72\x66\x5f\
\x6c\x65\x61\x64\x65\x72\x2e\x62\x70\x66\x2e\x63\0\x2e\x73\x74\x72\x74\x61\x62\
\0\x2e\x73\x79\x6d\x74\x61\x62\0\x2e\x72\x65\x6c\x2e\x42\x54\x46\0\x4c\x49\x43\
\x45\x4e\x53\x45\0\x4c\x42\x42\x30\x5f\x34\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xdd\0\0\0\x03\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\x15\x19\0\0\0\0\0\0\x05\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\x0f\0\0\0\x01\0\0\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x74\
\0\0\0\x01\0\0\0\x06\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x40\0\0\0\0\0\0\0\x80\x01\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x70\0\0\0\x09\0\0\
\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x60\x13\0\0\0\0\0\0\x30\0\0\0\0\0\0\0\x15\
\0\0\0\x03\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x96\0\0\0\x01\0\0\0\x03\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xc0\x01\0\0\0\0\0\0\x0d\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x29\0\0\0\x01\0\0\0\x03\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\xd0\x01\0\0\0\0\0\0\x60\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\xbf\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x30\x02\0\0\0\0\0\0\x69\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\x01\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x99\x02\0\0\0\0\
\0\0\x4a\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x5a\
\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xe3\x03\0\0\0\0\0\0\x30\x03\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x56\0\0\0\x09\0\0\
\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x90\x13\0\0\0\0\0\0\x80\x03\0\0\0\0\0\0\
\x15\0\0\0\x09\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x4b\0\0\0\x01\0\0\0\
\x30\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x13\x07\0\0\0\0\0\0\xfd\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\xf1\0\0\0\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\x10\x09\0\0\0\0\0\0\xa0\x05\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\x04\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xed\0\0\0\x09\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\x10\x17\0\0\0\0\0\0\x40\0\0\0\0\0\0\0\x15\0\0\0\x0c\0\0\0\x08\0\0\0\
\0\0\0\0\x10\0\0\0\0\0\0\0\x19\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\xb0\x0e\0\0\0\0\0\0\xc0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x04\0\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\x15\0\0\0\x09\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x50\x17\0\0\
\0\0\0\0\x90\x01\0\0\0\0\0\0\x15\0\0\0\x0e\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\
\0\0\0\xb2\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x70\x10\0\0\0\0\0\0\
\x28\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x08\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xae\0\0\0\
\x09\0\0\0\x40\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xe0\x18\0\0\0\0\0\0\x20\0\0\0\0\0\
\0\0\x15\0\0\0\x10\0\0\0\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\xa2\0\0\0\x01\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x98\x10\0\0\0\0\0\0\x76\x01\0\0\0\0\0\0\0\0\
\0\0\0\0\0\0\x01\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x9e\0\0\0\x09\0\0\0\x40\0\0\0\0\
\0\0\0\0\0\0\0\0\0\0\0\0\x19\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x15\0\0\0\x12\0\0\0\
\x08\0\0\0\0\0\0\0\x10\0\0\0\0\0\0\0\x88\0\0\0\x03\x4c\xff\x6f\0\0\0\x80\0\0\0\
\0\0\0\0\0\0\0\0\0\x10\x19\0\0\0\0\0\0\x05\0\0\0\0\0\0\0\x15\0\0\0\0\0\0\0\x01\
\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\xe5\0\0\0\x02\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\
\0\0\x10\x12\0\0\0\0\0\0\x50\x01\0\0\0\0\0\0\x01\0\0\0\x09\0\0\0\x08\0\0\0\0\0\
\0\0\x18\0\0\0\0\0\0\0";

	*sz = sizeof(data) - 1;
	return (const void *)data;
}

#ifdef __cplusplus
struct bperf_leader_bpf *bperf_leader_bpf::open(const struct bpf_object_open_opts *opts) { return bperf_leader_bpf__open_opts(opts); }
struct bperf_leader_bpf *bperf_leader_bpf::open_and_load() { return bperf_leader_bpf__open_and_load(); }
int bperf_leader_bpf::load(struct bperf_leader_bpf *skel) { return bperf_leader_bpf__load(skel); }
int bperf_leader_bpf::attach(struct bperf_leader_bpf *skel) { return bperf_leader_bpf__attach(skel); }
void bperf_leader_bpf::detach(struct bperf_leader_bpf *skel) { bperf_leader_bpf__detach(skel); }
void bperf_leader_bpf::destroy(struct bperf_leader_bpf *skel) { bperf_leader_bpf__destroy(skel); }
const void *bperf_leader_bpf::elf_bytes(size_t *sz) { return bperf_leader_bpf__elf_bytes(sz); }
#endif /* __cplusplus */

__attribute__((unused)) static void
bperf_leader_bpf__assert(struct bperf_leader_bpf *s __attribute__((unused)))
{
#ifdef __cplusplus
#define _Static_assert static_assert
#endif
#ifdef __cplusplus
#undef _Static_assert
#endif
}

#endif /* __BPERF_LEADER_BPF_SKEL_H__ */
